#ifndef glp_private_h
  #define glp_private_h

#include <linux/glp_device.h>
#include "../h/glp_types.h"
#include "../h/glp_basicio.h"

// FPGA configuration register set
// [
#define _L1_Q00 aPrivate.aCmdBuffer.aDevState.L1_Q00
#define _L1_Q01 aPrivate.aCmdBuffer.aDevState.L1_Q01
#define _L1_Q10 aPrivate.aCmdBuffer.aDevState.L1_Q10
#define _L1_Q11 aPrivate.aCmdBuffer.aDevState.L1_Q11
#define _L1_Q20 aPrivate.aCmdBuffer.aDevState.L1_Q20
#define _L1_Q21 aPrivate.aCmdBuffer.aDevState.L1_Q21
#define _L1_Q30 aPrivate.aCmdBuffer.aDevState.L1_Q30
#define _L1_Q31 aPrivate.aCmdBuffer.aDevState.L1_Q31
#define _L1_Q40 aPrivate.aCmdBuffer.aDevState.L1_Q40
#define _L1_Q41 aPrivate.aCmdBuffer.aDevState.L1_Q41
#define _L1_Q50 aPrivate.aCmdBuffer.aDevState.L1_Q50
#define _L1_Q51 aPrivate.aCmdBuffer.aDevState.L1_Q51
#define _L1_Q60 aPrivate.aCmdBuffer.aDevState.L1_Q60
#define _L1_Q61 aPrivate.aCmdBuffer.aDevState.L1_Q61
#define _L1_Q70 aPrivate.aCmdBuffer.aDevState.L1_Q70
#define _L1_Q71 aPrivate.aCmdBuffer.aDevState.L1_Q71

// Latch "2" Signale;
#define _L2_Q00 aPrivate.aCmdBuffer.aDevState.L2_Q00
#define _L2_Q01 aPrivate.aCmdBuffer.aDevState.L2_Q01
#define _L2_Q10 aPrivate.aCmdBuffer.aDevState.L2_Q10
#define _L2_Q11 aPrivate.aCmdBuffer.aDevState.L2_Q11
#define _L2_Q20 aPrivate.aCmdBuffer.aDevState.L2_Q20
#define _L2_Q21 aPrivate.aCmdBuffer.aDevState.L2_Q21
#define _L2_Q30 aPrivate.aCmdBuffer.aDevState.L2_Q30
#define _L2_Q31 aPrivate.aCmdBuffer.aDevState.L2_Q31
#define _L2_Q40 aPrivate.aCmdBuffer.aDevState.L2_Q40
#define _L2_Q41 aPrivate.aCmdBuffer.aDevState.L2_Q41
#define _L2_Q50 aPrivate.aCmdBuffer.aDevState.L2_Q50
#define _L2_Q51 aPrivate.aCmdBuffer.aDevState.L2_Q51
#define _L2_Q60 aPrivate.aCmdBuffer.aDevState.L2_Q60
#define _L2_Q61 aPrivate.aCmdBuffer.aDevState.L2_Q61
#define _L2_Q70 aPrivate.aCmdBuffer.aDevState.L2_Q70
#define _L2_Q71 aPrivate.aCmdBuffer.aDevState.L2_Q71
/// ]

//#define ucInterfaceMode pCmdBuf->status.ucInterfaceMode

// buffer- / instruction management
// [
// see /glp_device.h !
/*
struct tGLPCommand
  {
    dword aArg;
    dword aCmd;
  };

struct tGLPCmdBuffer
  {
    dword dError;
    dword dReturnValue[GLP_RET_NUM_BUFFER_MAX];
    struct tGLPCommand  aCmd[GLP_CMD_NUM_BUFFER_MAX];
    struct tGLPDevState aDevState;
  };
*/
// ]



// private struct //
struct tDevicePrivate
  {
    struct tGLPDeviceSettings aIOCfg;
    struct tGLPAdrLPT aLPTAddr;
    struct tGLPCmdBuffer aCmdBuffer;
//    struct tGLPDevState aDevState;

    struct tBasicIO aIO;
//    uchar bInterfaceMode;
    long dWriteTestCnt;
  };

#define BIOREF aPrivate.aIO

extern struct tDevicePrivate aPrivate; // in main source [galep-dev.c]

#endif // glp_private_h
